#! /bin/ksh
#
#pragma ident "@(#)es-setup.sh	1.34 01/09/04 Sun Microsystems"
#

basedir=`/usr/bin/pkgparam SUNWeswga BASEDIR`

if [ -z $"basedir" ]; then
    basedir=/opt
fi

ESWGS_SBIN=$basedir/SUNWsymon/addons/wgs/sbin
LNECK_CONF=$ESWGS_SBIN/sun4u-Sun-Fire-280R.conf
DAK_CONF=$ESWGS_SBIN/sun4u-Sun-Fire-880.conf
CSTONE_CONF=$ESWGS_SBIN/sun4u-Sun-Fire-480R.conf

. "$basedir"/SUNWsymon/sbin/es-common.sh

set_basedir
PROGNAME="$0"; export PROGNAME
check_root
check_logfile setup
check_osver
set_xput
setup_textdomain ESWG_SCRIPTS

echolog  '----------------------------------------------------------'
echolog  '         Starting Sun Management Center WGS Setup         '
echolog  '----------------------------------------------------------'

if [ -f /usr/platform/sun4u/sbin/prtdiag ] ; then
    prtline=`/usr/platform/sun4u/sbin/prtdiag | head -1`
    if [ $? -ne 0 ] ] ; then
        echolog 'Unable to determine platform'
        return 1
    fi
else
    echolog 'Unable to determine platform'
    return 1
fi

platform_list=`/usr/bin/pkgparam SUNWeswga ES_ADDON_PLATFORM`
if [ -z $"platform_list" ] ; then
  echolog 'Unable to determine package platform'
  return 1              # no platform list, return error
fi


if [ ! -f $VARDIR/base-modules-d.dat ] ; then
        /usr/bin/cp $BASEDIR/base/cfg/base-modules-d.dat $VARDIR/base-modules-d.dat
fi
   

# make dir if not there
mkdir -p ${PLATFORM_FILE%/*}
touch "$PLATFORM_FILE"
rm "$PLATFORM_FILE"
touch "$PLATFORM_FILE"

deviceinfo="/var/opt/SUNWsymon/cfg/deviceinfo.conf"

OIFS=$IFS
IFS=:,
# see if current platform is supported by WGS agent pkg.
for i in $platform_list;do
  echo "$prtline" | /usr/bin/grep "$i" > /dev/null 2>&1
  if [ $? -eq 0 ] ; then        # match
    echolog 'Platform Found\\: $i'
    NEW_MODEL=NO


    #
    # Build deviceinfo.conf file and stop/start picld for newer platforms


    if [ $i = "Sun Fire 280R" ] ; then

      NEW_MODEL=280R
      M=280r

    fi

    if [ $i = "Sun Fire 880" ]  ||  [ $i = "Sun Fire V880" ] ; then
      NEW_MODEL=880
      M=880

      #  SPECIAL CASE - REMOVE SunMC 3.0 PU1 files

      /bin/rm -f /usr/platform/SUNW,Sun-Fire-880/lib/picl/plugins/libsmcplugin.so.1 
      /bin/rm -f /usr/platform/SUNW,Sun-Fire-880/lib/picl/plugins/libsmcplugin.so 
      /bin/rm -f $basedir/SUNWsymon/base/lib/sparc-sun-solaris2.8/libcfgnewpiclWG.so.1.0
      /bin/rm -f $basedir/SUNWsymon/base/lib/sparc-sun-solaris2.8/libcfgnewpiclWG.so

    fi

    if [ $i = "Sun Fire 480R" ] || [ $i = "Sun Fire V480" ] ; then

      NEW_MODEL=480R
      M=480r

    fi

# *****************************************

    if [ $i = "StorEdge(TM) N8200 filer" ] ; then
      if [ -f $deviceinfo ] ; then
	rm $deviceinfo
      fi
      touch $deviceinfo
      cat << END_OF_INPUT > $deviceinfo
DID Enterprise-220R
OID 1.3.6.1.4.1.42.2.12.3.1.12
FAMILYTYPE sun4u-Sun-Enterprise-220R
END_OF_INPUT
    fi

# *****************************************

    if [ $i = "StorEdge(TM) N8400 filer" ] ; then
      if [ -f $deviceinfo ] ; then
	rm $deviceinfo
      fi
      touch $deviceinfo
      cat << END_OF_INPUT > $deviceinfo
DID Enterprise-420R
OID 1.3.6.1.4.1.42.2.12.3.1.12
FAMILYTYPE sun4u-Sun-Enterprise-420R
END_OF_INPUT
    fi

# *****************************************

################################################################################
        if [ $i = "Enterprise 450" ] ; then
                if [ -f $deviceinfo ] ; then
                        rm $deviceinfo
                fi
                touch $deviceinfo
                cat << END_OF_INPUT > $deviceinfo
DID Sun-Enterprise-450
OID 1.3.6.1.4.1.42.2.12.3.2.3
FAMILYTYPE sun4u-Ultra-Enterprise-450
END_OF_INPUT
        fi

################################################################################

        if [ $i = "Ultra 450" ] ; then
                if [ -f $deviceinfo ] ; then
                        rm $deviceinfo
                fi
                touch $deviceinfo
                cat << END_OF_INPUT > $deviceinfo
DID Sun-Enterprise-450
OID 1.3.6.1.4.1.42.2.12.3.2.3
FAMILYTYPE sun4u-Ultra-Enterprise-450
END_OF_INPUT
        fi

################################################################################

        if [ $i = "Ultra 2" ] ; then
                if [ -f $deviceinfo ] ; then
                        rm $deviceinfo
                fi
                touch $deviceinfo
                cat << END_OF_INPUT > $deviceinfo
DID Sun-Ultra-Enterprise-2
OID 1.3.6.1.4.1.42.2.12.3.1.2
FAMILYTYPE sun4u-Ultra-Enterprise-2
END_OF_INPUT
        fi

################################################################################


# *****************************************

    if [ $NEW_MODEL != "NO" ] ; then

      if [ -f $deviceinfo ] ; then
	rm $deviceinfo
      fi

      touch $deviceinfo

      cat << END_OF_INPUT > $deviceinfo
DID Sun-Fire-$NEW_MODEL
OID 1.3.6.1.4.1.42.2.12.3.1.12
FAMILYTYPE sun4u-Sun-Fire-$NEW_MODEL
END_OF_INPUT

A=SUNW,Sun-Fire-$NEW_MODEL
RELEASE=`/usr/bin/uname -r | sed 's/^5/2/' | cut -d\. -f1,2`
	
      /bin/rm -f /usr/platform/sun4u/lib/sunmc_common.conf
      cp $basedir/SUNWsymon/lib/platform/cfg/sunmc_common.conf /usr/platform/sun4u/lib/sunmc_common.conf

      /bin/rm -f /usr/platform/"$A"/lib/picl/plugins/libsunmcplugin.so.1 
      /bin/rm -f /usr/platform/"$A"/lib/picl/plugins/libsunmcplugin.so 
     
      cp $basedir/SUNWsymon/base/lib/sparc-sun-solaris"$RELEASE"/libsunmcplugin.so.1 /usr/platform/"$A"/lib/picl/plugins/libsunmcplugin.so.1
      
      ln -s  /usr/platform/"$A"/lib/picl/plugins/libsunmcplugin.so.1  /usr/platform/"$A"/lib/picl/plugins/libsunmcplugin.so

      /bin/rm -f /usr/platform/"$A"/lib/libsunmc"$M"plugin.so.1
      /bin/rm -f /usr/platform/"$A"/lib/sunmcplugin.conf

      cp $basedir/SUNWsymon/lib/platform/cfg/"$A"/libsunmc"$M"plugin.so.1 /usr/platform/"$A"/lib/libsunmc"$M"plugin.so.1

      cp $basedir/SUNWsymon/lib/platform/cfg/"$A"/sunmcplugin.conf /usr/platform/"$A"/lib/sunmcplugin.conf

      /bin/rm -f /usr/platform/sun4u/lib/sunmc_common.conf
      cp $basedir/SUNWsymon/lib/platform/cfg/sunmc_common.conf /usr/platform/sun4u/lib

# Stop picld (twice if necessary) and then restart it, so it will recognize SunMC plugin.

      status=`ps -ef | grep picld | grep -v grep |  wc -l `

      if [ $status -ge 1 ]; then
         /etc/init.d/picld stop ; sleep 1	# stop it once.
         status=`ps -ef | grep picld | grep -v grep | wc -l `
         if [ $status -ge 1 ]; then
            /etc/init.d/picld stop		# stop it again if it still exists.
            sleep 1
	 fi
      fi
      /etc/init.d/picld start

    fi		# END OF NEW_MODEL BLOCK
    
    

    if [ $i = "Ultra 5/10" ] ; then
                        if [ -f $deviceinfo ] ; then
                                rm $deviceinfo
                        fi
                        touch $deviceinfo
                        cat << END_OF_INPUT > $deviceinfo
DID Sun-Ultra-Enterprise-5,10
OID 1.3.6.1.4.1.42.2.12.3.1.3
FAMILYTYPE sun4u-Sun-Ultra-Enterprise-5,10
END_OF_INPUT

           question="Enter the platform type [1\\\|2]: "
           answer=""
           while [ "$answer" = "" ]
           do
              echolog 'Choose the platform you are installing the agent on:'
              echolog '1.  Ultra Enterprise 5'
              echolog '2.  Ultra Enterprise 10'
              if [ "$LOGFILE" != "" ] ; then
                 eval echo `gettext "$question"` " \\\c" >> "$LOGFILE"
              fi 
              eval echo `gettext "$question"` " \\\c"
              read answer
              if [ "$LOGFILE" != "" ] ; then
                 echo "$answer" >> "$LOGFILE"
              fi 
              case "$answer" in
                1) echo "UltraModel=5" >> "$PLATFORM_FILE"
                    break ;;
                2) echo "UltraModel=10" >> "$PLATFORM_FILE"
                    break ;;
                 *) answer=""
              esac
          done
    fi
#   ask_user "Do you want to set up the workgroup server config reader for this platform?"
#   if [ $answer -eq 1 ] ; then         # yes, setup
      # See if entry is already there
      /usr/bin/grep WGSETUP "$PLATFORM_FILE" > /dev/null 2>& 1
      if [ $? -eq 1 ] ; then    # WGSSETUP not there yet, add it
        echo "WGSETUP" >> "$PLATFORM_FILE"
      fi

     

   /usr/bin/grep Config-Reader4uwg "$VARDIR"/base-modules-d.dat > /dev/null 2>& 1


      if [ $? -eq 1 ] ; then
        echo "Config-Reader4uwg = \".iso.org.dod.internet.private.enterprises.sun.prod.sunsymon.agent.modules.hardware.Config.Reader4uwg sun Config-Reader4uwg {i18nModuleType = \\\"base.modules.Config-Reader4uwg:moduleType\\\"; enterprise = \\\"sun\\\"; module = \\\"Config-Reader4uwg\\\"; console = \\\"Config-Reader4uwg\\\"; version = \\\"1.0\\\"; moduleName = \\\"Config Reader (Workgroup Server)\\\"; i18nModuleName = \\\"base.modules.Config-Reader4uwg:moduleName\\\"; moduleType = \\\"hardware\\\"; instance = \\\"\\\"; }\"" >> "$VARDIR"/base-modules-d.dat
      fi        # end grep match
#   fi  # end $answer==1
    # Done, platform was matched and either setup or not
    IFS=$OIFS
    return 0
  fi  # end match
done  # end for platform_list
IFS=$OIFS
 
# No match
return 0

